#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <unistd.h>

// スレッドのデータ構造
struct ThreadData{
    int value;// ソートする値
};

// スレッド関数
void* sleepSort(void* data){
    struct ThreadData* _data=(struct ThreadData*)data;
    int value=_data->value;
    
    sleep(value);// スリープ時間を値に設定
    printf("%d ",value);// ソートされた値を出力
    free(_data);

    return NULL;
}

int main(){
    int n=6;
    int a[]={6,1,5,2,8,4,9};
    
    for (int i=0;i<n;i++){
        printf("%d ",a[i]);
    }
    printf("\n");

    // 各要素をスレッドとして起動し、スリープソートを行う
    for (int i=0;i<n;i++){
        int value=a[i];

        struct ThreadData* _data=(struct ThreadData*)malloc(sizeof(struct ThreadData));
        _data->value=value;
        pthread_t thread;
        pthread_create(&thread,NULL,sleepSort,_data);
        pthread_detach(thread);// スレッドをデタッチする
    }

    // 最大の値に1を加えた時間だけ待つことで、ソートが終了するのを確認
    int _max=0;
    for (int i=0;i<n;i++){
        if (a[i]>_max){
            _max=a[i];
        }
    }
    sleep(_max + 1);

    printf("\n");
    return 0;
}
